<script>
import { ref, computed, onMounted, reactive } from "vue";
import store from "@/store"
import useValidate from "@vuelidate/core";
import { required, email, minLength, sameAs, helpers } from "@vuelidate/validators";
import { HTTP } from "@/components/common/HttpCommon";

import Loading from '@/components/item/Loading.vue';
import ProductForm from '@/components/forms/ProductForm.vue'
export default {
  components: { Loading, ProductForm },
  name: 'ProductView',
  props: {
  },
  data() {
    return {
        formTitle: null,
        showForm : false,
        modalShow: false,
        formData: null,
        userRole: store.state.userRole,
        success: null,
        popupAlertsShow: false
    }
  },
  setup() {
    const data = ref(null);
    const size = ref(0);
    const loading = ref(false);
    const error = ref(null);
    const state = reactive({
            name : '',
            email : '',
            username : '',
            password : {
               confirm: '',
               password: ''
            },
            agree : false
         });
    const rules = computed(() => {
         return {
            name : { required },
            email : { required, email },
            username : { required },
            password : { 
               password : {required },
               confirm : { required, sameAs : sameAs( state.password.password ) }
            },
            agree : { sameAs : sameAs ( true ) }
         }
    });
    const v$ = useValidate(rules, state)
    async function fetchData() {
      loading.value = true;
      const result = await HTTP.get(`products`).then(response => {
            data.value = response.data.data.content
            size.value = response.data.data.content.length
         })
         .catch(e => {
            console.log(e)
         })
      loading.value = false;
    }
    function deleteData(id){

    }

    onMounted(() => {
      fetchData();
    });

    return {
      data,
      size,
      loading,
      error,
      state,
      v$,
      deleteData,
      fetchData
    };
  },methods: {
    doSignIn() {
      localStorage.signup = !store.state.signup
      store.commit('togleSignUp')
      location.reload()
    },
    formModalDone() {
        this.modalShow = !this.modalShow
        this.$nextTick().then(() => {
            this.fetchData()
        })
    },
    showModalProduct(title, index) {
       this.formTitle = title
       if(title != 'Add Product'){
           this.formData = this.data[index]
       }else{
           this.formData = null
       }
       this.$nextTick().then(() => {
           if(title == 'Delete Product'){
            this.deleteData(this.formData.id)
           }else{
            this.modalShow = !this.modalShow
           }
       });
    },
    async addBasket(item){
        let bakset = [];
        bakset = localStorage.getItem('keranjang') ? JSON.parse(localStorage.getItem('keranjang')) || [] : [];
        this.success = "Item Already on Basket";
        if(bakset.findIndex(x => x.id === item.id) < 0){
            bakset.push(item);
            this.success = "Succes Add Basket";
        }
        this.popupAlertsShow = !this.popupAlertsShow;
        setTimeout(() => {
            this.popupAlertsShow = !this.popupAlertsShow;
        },1000)
        await localStorage.setItem('keranjang', JSON.stringify(bakset));
    }
  }
}
</script>
<template> 
    <div class="container-fluid">
        <Loading v-if="loading" />
        <div class="row" v-if="!loading">
            <div class="col-lg-12" v-if="modalShow">
                <ProductForm v-if="modalShow" @close-modal="modalShow = !modalShow" @form-modal-done="formModalDone" :title="formTitle" :data="formData" />
            </div>
            <div class="col-lg-12" v-if="!modalShow">
                <div class="d-flex flex-wrap flex-wrap align-items-center justify-content-between mb-4">
                    <div>
                        <h4 class="mb-3">Product List</h4>
                        <!-- <p class="mb-0">The product list effectively dictates product presentation and provides space<br> to list your products and offering in the most appealing way.</p> -->
                    </div>
                    <a v-if="userRole == 'USER'" href="basket" class="btn btn-success add-list" ><i class="ri-shopping-cart-line"></i>Basket</a>
                    <a v-if="userRole == 'ADMIN'" href="#add-product" class="btn btn-primary add-list" @click="showModalProduct('Add Product')" ><i class="ri-add-fill"></i>Add Product</a>
                </div>
            </div>
            <div class="col-lg-12" v-if="!modalShow">
                <div class="table-responsive rounded mb-3">
                <table class="data-tables table mb-0 tbl-server-info">
                    <thead class="bg-white text-uppercase">
                        <tr class="ligth ligth-data">
                            <!-- <th>
                                <div class="checkbox d-inline-block">
                                    <input type="checkbox" class="checkbox-input" id="checkbox1">
                                    <label for="checkbox1" class="mb-0"></label>
                                </div>
                            </th> -->
                            <th>Name</th>
                            <th>Code</th>
                            <th>Price</th>
                            <th>Unit</th>
                            <th>Weight</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody class="ligth-body">
                        <tr v-if="data && size > 0" v-for="(item, index) in data">
                            <!-- <td>
                                <div class="checkbox d-inline-block">
                                    <input type="checkbox" class="checkbox-input" id="checkbox2">
                                    <label for="checkbox2" class="mb-0"></label>
                                </div>
                            </td> -->
                            <td>
                                <div class="d-flex align-items-left">
                                    <img v-if="item.image" :src="item.image || '../assets/images/table/product/01.jpg'" class="img-fluid rounded avatar-50 mr-3" alt="image">
                                    <img v-if="!item.image" src="../assets/images/table/product/01.jpg" class="img-fluid rounded avatar-50 mr-3" alt="image">
                                    <div>
                                        {{item.name}}
                                        <p class="mb-0"><small>{{item.description}}</small></p>
                                    </div>
                                </div>
                            </td>
                            <td>{{item.code}}</td>
                            <td>SR. {{item.price}}</td>
                            <td>{{item.unit}}</td>
                            <td>{{item.weight || '-'}}</td>
                            <td>
                                <div v-if="userRole == 'ADMIN'" class="d-flex align-items-left list-action">
                                    <a class="badge badge-info mr-2" :href="'#view-product-' + item.id" v-b-modal.modal-1 @click="showModalProduct('View Detail Product', index)" ><i class="ri-eye-line mr-0"></i></a>
                                    <a class="badge bg-success mr-2" :href="'#edit-product-' + item.id" v-b-modal.modal-1 @click="showModalProduct('Edit Product', index)" ><i class="ri-pencil-line mr-0"></i></a>
                                     <a class="badge bg-warning mr-2" :href="'#delete-product-' + item.id" v-b-modal.modal-1 @click="showModalProduct('Delete Product')" ><i class="ri-delete-bin-line mr-0"></i></a>
                                </div>
                                <div v-if="userRole == 'USER'" class="d-flex align-items-left list-action">
                                    <a class="badge badge-info mr-2" :href="'#view-product-' + item.id" v-b-modal.modal-1 @click="showModalProduct('View Detail Product', index)" ><i class="ri-eye-line mr-0"></i></a>
                                    <a class="badge bg-success mr-2" :href="'#order-product-' + item.id" @click="addBasket(item)" ><i class="ri-add-line"></i><i class="ri-shopping-cart-line mr-0"></i></a>
                                </div>
                            </td>
                        </tr>
                        <tr v-if="size <= 0">
                            <td colspan="7"><i><strong> No Data Found </strong></i></td>
                        </tr>
                    </tbody>
                </table>
                </div>
            </div>
        </div>
        <!-- Page end  -->
    </div>
    <b-modal v-model="popupAlertsShow" id="popup-alerts" hide-footer hide-header >
        <div class="col-md-12" v-if="error || success">
            <div class="alert alert-danger" v-if="error">
                <div class="iq-alert-text">
                {{error}}
                </div>
            </div>                    
            <div class="alert alert-success" v-if="success">
                <div class="iq-alert-text">
                {{success}}
                </div>
            </div>
        </div>
    </b-modal>
</template>
<style scoped>
.align-items-left{
    text-align: left;
}
</style>